<template>
  <div class="card">
    <h3>{{ user.name }}</h3>
    <label><strong>{{ user.role }}</strong></label>
    <label>{{ user.email }}</label>
    <dynamic-form
    v-on:success="editUserSuccessful"
    headerText="Edit User"
    buttonText="Submit Changes"
    :endpointUrl="'/api/users/' + user._id"
    endpointType="put"
    :fields="[
      {
        name: 'name',
        label: 'Name',
        type: 'text',
        required: true,
        value: user.name,
      },
      {
        name: 'role',
        label: 'Role',
        type: 'dropdown',
        required: true,
        value: user.role,
        options: [
          {
            value: 'regular',
            label: 'Regular',
          },
          {
            value: 'owner',
            label: 'Owner',
          },
          {
            value: 'admin',
            label: 'Admin',
          },
        ],
      },
      {
        name: 'email',
        label: 'Email',
        type: 'email',
        required: true,
        value: user.email,
      },
    ]"
    v-if="edit">
    </dynamic-form>
    <span class="edit-delete-buttons">
      <input type="button"
      :disabled="edit"
      class="edit-button"
      v-on:click="editUser()"
      value="Edit user">
      <input type="button"
      class="delete-button"
      v-on:click="deleteUser()"
      value="Delete user">
    </span>
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </div>
</template>

<script>
import store from '../store/index';
import dynamicForm from './DynamicForm.vue';
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  components: {
    dynamicForm,
  },
  props: {
    user: Object,
    index: Number,
  },
  data() {
    return {
      edit: false,
      loading: false,
    };
  },
  methods: {
    editUser() {
      this.edit = true;
    },
    editUserSuccessful(response) {
      this.edit = false;
      // update user in the frontend
      store.commit('editUserSuccessful', {
        user: response.data,
        index: this.index,
      });
    },
    deleteUser() {
      // toggle loading spinner on
      this.loading = true;
      // http request
      axios.delete(proxy + '/api/users/' + this.user._id).then((response) => {
        // remove user in the frontend
        store.commit('deleteUserSuccessful', {
          index: this.index,
        });
        // toggle loading spinner off
        this.loading = false;
      }).catch((error) => {
        // log error message
        console.log({ error: error.message });
        // toggle loading spinner off
        this.loading = false;
      });
    },
  },
}
</script>

<style lang="scss">

</style>
